static adata cm_pointer (unsigned char *ptr,adata temp) {
	unsigned char b1,b2;
	unsigned short tmp1,tmp2;
	b1 = *ptr;
	while (b1 != 0x00) {
		ptr++;
		b1 = *ptr;
		(temp.ptr1)++;
		(temp.ptr2)++;
	}
	ptr++;
	(temp.ptr1)++;
	(temp.ptr2)++;
	if((hexcmp((char *) ptr,"\001\000\000\000",4)) == 0) {
		ptr += 4;
		temp.type = *ptr;
		temp.ptr1 += 5;
		temp.ptr2 += 5;
	} else {
		temp.type = 0;
	}
	if (temp.type == 3) {
		ptr = temp.ptr1;
		b1 = *(temp.ptr1);
		(temp.ptr1)++;
		b2 = *(temp.ptr1);
		(temp.ptr1)++;
		tmp1 = ((b2 & 0xFF) << 8) + (b1 & 0xFF);
		b1 = *(temp.ptr1);
		(temp.ptr1)++;
		b2 = *(temp.ptr1);
		(temp.ptr1)++;
		tmp2 = ((b2 & 0xFF) << 8) + (b1 & 0xFF);
		temp.ptr1 = ptr;
		temp.ptr1 += tmp1;
		temp.ptr2 += tmp2;
	}
	return temp;
}

static bool ti83series (char *filename) {
	FILE *file;
	char *ext = strrchr(filename,'.');
	if (((strcasecmp(ext,".83p")) & (strcasecmp(ext,".8xp"))) != 0)
		return FALSE;
	if ((file = fopen(filename,"rb")) == NULL)
		return FALSE;
	char buf[12];
	if((fread(buf,1,12,file)) != 12) {
		fclose(file);
		return FALSE;
	}
	fclose(file);
	if ( ( (hexcmp(buf,"**TI83**\032\012\000",11)) & (hexcmp(buf,"**TI83F*\032\012\000",11)) ) != 0) {
		return FALSE;
	}
	return TRUE;
}

static hdata calcmod (char *filename) {
	hdata tmp =
	{
		74,
		9,
		"\311Calcmod\000"
	};
	return tmp;
}

static finfo cm_info (char *filename) {
	FILE *file;
	int len = 0;
	unsigned char buf[1];
	finfo tmp = {
		NULL,
		-1,
	};
	if ((file = fopen(filename,"rb")) == NULL) {
		tmp.title = (char *) ("File non-existant");
		tmp.length = -1;
		return tmp;
	}
	if((fseek(file,83,SEEK_SET)) != 0) {
		tmp.title = (char *) ("Incorrect file format");
		tmp.length = -1;
		return tmp;
	}
	buf[0] = 0xFF;
	while (buf[0] != 0x00) {
		fread(buf,1,1,file);
		len++;
	}
	fseek(file,83,SEEK_SET);
	tmp.title = (char *) malloc(len+1);
	fread((char *) tmp.title,1, len, file);
	fclose(file);
	return tmp;
}

static adata cm_read(adata temp) {
	unsigned char tmp1 = 0,tmp2 = 0,p1 = 0,p2 = 0;
	unsigned short tfreq;
	unsigned long tperiod;
	if (temp.type == 0) {
		tmp1 = *(temp.ptr1);
		(temp.ptr1)++;
		tmp2 = *(temp.ptr1);
		(temp.ptr1)++;
		p1 = *(temp.ptr1);
		(temp.ptr1)++;
		p2 = *(temp.ptr1);
		(temp.ptr1)++;
		tfreq = ((tmp2 & 0xFF) << 8) + (tmp1 & 0xFF);
		tperiod = ((p2 & 0xFF) << 8) + (p1 & 0xFF);
		if ((tfreq == 0x0000) || (tperiod == 0x0000))
			temp.eof = TRUE;
		if (tfreq <= 8) {
			tperiod = (unsigned long int) ((((double) tperiod) * (5 / ((double) tfreq))) / 5.502675737);
			temp.freq[0] = tperiod+1;
			temp.freq[1] = tperiod+1;
		} else {
			tperiod = (unsigned long int) ((((double) tperiod) * ((double) tfreq)) / 5.502675737);
		}
		tfreq = tfreq / 2;
		temp.period[0] = tperiod;
		temp.period[1] = tperiod;
		temp.freq[0] = tfreq;
		temp.freq[1] = tfreq;
		temp.tf = temp.freq;
		return temp;
	}
	if (temp.type == 1) {
		tmp1 = *(temp.ptr1);
		(temp.ptr1)++;
		tmp2 = *(temp.ptr1);
		(temp.ptr1)++;
		p1 = *(temp.ptr1);
		(temp.ptr1)++;
		p2 = *(temp.ptr1);
		(temp.ptr1)++;
		if ((tmp1 == 0xFF) || (tmp2 == 0xFF))
			temp.eof = TRUE;
		temp.freq[0] = (unsigned int) (44100 / equates[tmp1]);
		temp.freq[1] = (unsigned int) (44100 / equates[tmp2]);
		tperiod = ((p2 & 0xFF) << 8) + (p1 & 0xFF);
		if (tperiod == 0xFFFF)
			temp.eof = TRUE;
		temp.period[0] = (unsigned long int) (((double) tperiod) * 2.691650391);
		temp.period[1] = temp.period[0];
		if (tmp1 == 72)
			temp.freq[0] = temp.period[0]+1;
		if (tmp2 == 72)
			temp.freq[1] = temp.period[1]+1;
		temp.tf = temp.freq;
		return temp;
	}
	if (temp.type == 2) {
		tmp1 = *(temp.ptr1);
		(temp.ptr1)++;
		p1 = *(temp.ptr1);
		(temp.ptr1)++;
		p2 = *(temp.ptr1);
		(temp.ptr1)++;
		tperiod = ((p2 & 0xFF) << 8) + (p1 & 0xFF);
		temp.freq[0] = (unsigned int) (44100 / equates[tmp1]);
		temp.freq[1] = temp.freq[0];
		temp.period[0] = (unsigned long int) (((double) tperiod) * 2.691650391);
		temp.period[1] = temp.period[0];
		if (tmp1 == 72) {
			temp.freq[0] = temp.period[0]+1;
			temp.freq[1] = temp.freq[0];
		}
		if ((tmp1 == 0xFF) || (tperiod == 0xFFFF))
			temp.eof = TRUE;
		temp.tf = temp.freq;
		return temp;
	}
	if (temp.type == 3) {
		if (temp.period[0] == 0) {
			tmp1 = *(temp.ptr1);
			(temp.ptr1)++;
			p1 = *(temp.ptr1);
			(temp.ptr1)++;
			p2 = *(temp.ptr1);
			(temp.ptr1)++;
			tperiod = ((p2 & 0xFF) << 8) + (p1 & 0xFF);
			temp.period[0] = (unsigned long int) (((double) tperiod) * 3.687561036);
			temp.freq[0] = (unsigned int) (44100 / equates[tmp1]);
			if ((tmp1 == 0xFF) || (tperiod == 0xFFFF))
				temp.eof = TRUE;
			if (tmp1 == 72)
				temp.freq[0] = temp.period[0]+1;
			temp.tf[0] = temp.freq[0];
		}
		if (temp.period[1] == 0) {
			tmp1 = *(temp.ptr2);
			(temp.ptr2)++;
			p1 = *(temp.ptr2);
			(temp.ptr2)++;
			p2 = *(temp.ptr2);
			(temp.ptr2)++;
			tperiod = ((p2 & 0xFF) << 8) + (p1 & 0xFF);
			temp.period[1] = (unsigned long int) (((double) tperiod) * 3.687561036);
			temp.freq[1] = (unsigned int) (44100 / equates[tmp1]);
			if ((tmp1 == 0xFF) || (tperiod == 0xFFFF))
				temp.eof = TRUE;
			if (tmp1 == 72)
				temp.freq[1] = temp.period[1]+1;
			temp.tf[1] = temp.freq[1];
		}
		return temp;
	}
	temp.eof = TRUE;
	return temp;
}

